#!/usr/bin/env python

from numpy import *
import matplotlib.pyplot as plt
import csv
import serial

# function defintion that aids in the use of map()
def subtract128(x):
    return x-128

def main():
    x = range(5000)
    
    data = [] # array for storing all data sent by the microcontroller of sampled ADC values
    motion = [] # array for storing all results of motion detection
    
    ser = serial.Serial('COM4',9600,timeout=60) # opens a new communication port
    
    print "Reading in..."
    line = ser.readline() # reads all data - data is formatted as one long string on one line for this to work
    
    readStuff = line.split(",")
    
    # simple state machine to iterate over all the elements in the array and sort thm into two arrays
    state = "";
    for element in readStuff:
        if element == "Data":
            state = "Data"
            continue
        if element == "Motion":
            state = "Motion"
            continue
        if state == "Data":
            data.append(element)
        if state == "Motion":
            motion.append(element)
    
    # parse data
    data = map(int, data)
    data = map(subtract128, data)
    
    # plot the data
    plt.plot(x,data)
    
    # arrays for streamlining string manipulation
    start = []
    end = []
    secondEnd = []
    
    # finding indices
    for element in motion:
        start.append(element.find("("))
        end.append(element.find("|"))
        secondEnd.append(element.find(")"))
    
    # plot vertical lines to indicate start and end of blocks
    for i in range(len(start)):
        if int(motion[i][0]) != 0:
            # black lines for beginning of block
            plt.vlines(int(motion[i][start[i]+1:end[i]]), -128, 128, color='k', linestyles='solid')
            # red lines for end of block
            plt.vlines(int(motion[i][end[i]+1:secondEnd[i]]), -128, 128, color='r', linestyles='solid')
        # label pushes and pulls
        if int(motion[i][0]) == 1:
            plt.text(int(motion[i][start[i]+1:end[i]]), 100, "Push")
        if int(motion[i][0]) == 2:
            plt.text(int(motion[i][start[i]+1:end[i]]), 100, "Pull")
        
    plt.show()
    
main()
